#pragma once

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <unordered_set>
#include "DataStructures.h"
#include <map>

class MeshLoader 
{
protected:
	std::set<Node> nodes; //!!! Плохой выбор контейнера - vector чем не подходит?
	std::set<FiniteElement> elements; //!!! Плохой выбор контейнера - vector чем не подходит?
	std::multiset<BoundaryFiniteElement> boundaryFEs; //!!! Плохой выбор контейнера - vector чем не подходит?

	std::unordered_set<Edge, std::hash<Edge>> edges;
public:
	virtual void LoadMesh(const std::string&) = 0;
	virtual ~MeshLoader() = default;

	// ,   STL- ,     
	std::set<Node> getNodes();
	std::set<FiniteElement> getFiniteElements();
	std::multiset<BoundaryFiniteElement> getBoundaryFiniteElements();

	// ,     ID    
	std::vector<FiniteElement> getElementsByID(int, int, int);

	// ,     ,    ID  
	std::vector<FiniteElement> getElementsByEdge(int, int);

	// ,      ID 
	std::vector<Node> getNodesByBoundary(int);

	// ,      ID 
	std::vector<FiniteElement> getElementsByBoundary(int);

	// ,       ID 
	std::vector<BoundaryFiniteElement> getsboundaryFEsByBoundary(int);

	// ,         
	void insertCenterNode();

	// ,  , n -            n
	std::map<int,std::vector<Node>> getNodeNeighbours();

	// ,    Node, FiniteElement  BoundaryFiniteElement  
	void Print_Data();

	// ,     ID  
	std::vector<FiniteElement> getElementsByOneID(int);

	
	

	//,  ID  
	int getLastNodeID();

	//,      ID 
	std::set<Node>::iterator getNodeByID(int id);

	

	std::unordered_set<Edge, std::hash<Edge>> deleteEdgesDublicates();
	//void sortEdges(std::vector<Edge>&);
};